:: Simple script to block an ip using netsh-advfirewall.
:: Copyright (C) 2015-2019, Wazuh Inc.
@ECHO OFF
ECHO.


:: Logging it all
FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE/T') DO SET DATE=%%B
FOR /F "TOKENS=1* DELIMS= " %%A IN ('TIME/T') DO SET TIME=%%A
ECHO %DATE% %TIME% %0 %1 %2 %3 %4 %5 %6 %7 %8 %9 >> active-response/active-responses.log

:: Checking if IP is whitelisted locally
find /c "%3" ukfast-data/active-response-ip-whitelist.txt  && ( echo %DATE% %0  UKFast Dynamic Protection: IP is Whitelisted - %3 IP was not blocked >> active-response/active-responses.log && ( exit 1 ) )

:: Checking if Rule ID is whitelisted locally
find /c "%5" ukfast-data/active-response-ruleid-whitelist.txt  && ( echo %DATE% %0  UKFast Dynamic Protection: Rule ID is Whitelisted - %5 IP was not blocked >> active-response/active-responses.log && ( exit 1 ) )


IF "%1"=="add" GOTO ADD
IF "%1"=="delete" GOTO DEL
:ERROR

ECHO "Invalid argument. %1"
GOTO Exit;


:: Adding to the blocked.

:ADD
:: Extracts last ip address from ipconfig.
netsh advfirewall firewall add rule name="WAZUH ACTIVE RESPONSE BLOCKED IP" interface=any dir=in action=block remoteip=%3/32
GOTO Exit;

:DEL
netsh advfirewall firewall delete rule name="WAZUH ACTIVE RESPONSE BLOCKED IP" remoteip=%3/32

:Exit